<?php
define("_VALID_PHP", true);

define( 'BASEPATH', dirname(dirname(dirname(__FILE__))) . '/' );

$configFile = BASEPATH . "lib/config.ini.php";
if (file_exists($configFile)) {
	require_once ($configFile);
} else {
	exit("Configuration file is missing. bitpay Installer can not continue.");
}

$configFile = BASEPATH . "lib/config.ini.php";

require_once (BASEPATH . "lib/class_registry.php");

require_once (BASEPATH . "lib/class_db.php");

Registry::set('Database', new Database(DB_SERVER, DB_USER, DB_PASS, DB_DATABASE));
$db = Registry::get("Database");
$db->connect();

      $db->query("
		  INSERT INTO `gateways` (`name`, `displayname`, `dir`, `demo`, `extra_txt`, `extra_txt2`, `extra_txt3`, `extra`, `extra2`, `extra3`, `info`, `active`) VALUES
		  ('bitpay', 'bitpay', 'bitpay', 0, 'bitpay API', 'Currency Code', '', 'adxcv-zzadq-polkjsad-opp13opoz-1sdf455aadzmck1244567', 'IRR', '', '&lt;p&gt;&lt;a href=&quot;https://bitpay.ir/signinsignup&quot; title=&quot;https://bitpay.ir/signinsignup; rel=&quot;nofollow&quot;&gt;  ǘ    .&lt;/a&gt;&lt;/p&gt;\r\n&lt;p&gt;&lt;strong&gt; ѐ&lt;/strong&gt; -  ѐ    ..&lt;/p&gt;\r\n&lt;p&gt;&lt;strong&gt;&lt;/strong&gt; -     ѐ  yes     . &lt;br&gt;\r\n  ǐ  ǘ     ѐ   ѐ        .&lt;/p&gt;\r\n&lt;p&gt;&lt;strong&gt; &lt;/strong&gt; -   ѐ       API   .&lt;/p&gt;\r\n&lt;p&gt;&lt;strong&gt;IPN Url&lt;/strong&gt; - This option it&#039;s not being used.&lt;/p&gt;\r\n&lt;/ul&gt;', 1);
		");

echo 'Setup done.<br>Now check if you can see bitpay in gateways list in admin.<br> After that remove the file bitpay-setup.php from bitpay directory in gateways.';
die();