<?php
/**
 * bitpay IPN
 *
 * @author farhan
 * @copyright 2015
 * @version $Id: ipn.php,<?php echo  2010-08-10 21:12:05 gewa Exp $
 */
define("_VALID_PHP", true);
define("_PIPN", true);

require_once("../../init.php");
require_once("../../lib/class_filter.php");
/* only for debuggin purpose. Create logfile.txt and chmod to 0777
ob_start();
echo '<pre>';
print_r($_POST);
echo '</pre>';
$logInfo = ob_get_contents();
ob_end_clean();

$file = fopen('logfile.txt', 'a');
fwrite($file, $logInfo);
fclose($file);
 */

/* Check for mandatory fields */
$r_fields = array(
      'trans_id', 
      'id_get'
);

$plmessage = '';
$failed = false;
foreach ($r_fields as $f)
    if (!isset($_POST[$f]))
        die('Moshakhasate pardakht be dorosti daryaft nashod !');
if( ! isset($_GET['data']))
    die();
$data = base64_decode( $_GET['data'] );

parse_str( $data, $data );

$row = Core::getRowById("gateways", $data['pl_id']);


// Check if payment really succeded
if( ! $row->demo ) 
{
    $api = 'adxcv-zzadq-polkjsad-opp13opoz-1sdf455aadzmck1244567';
    $url = 'https://bitpay.ir/payment-test/gateway-result-second';
}
else 
{
    $api = $row->extra;
    $url = 'https://bitpay.ir/payment/gateway-result-second';
}

if( ! isset( $_POST['trans_id'] ) || ! isset( $_POST['id_get'] ) )
{
    $plmessage = 'به نظر می رسد درگاه بیت پی دچار مشکلی شده و یا قواعد اتصال به درگاه تغییر کرده لطفا مسئول سایت را از این موضوع مطلع نمایید.';
    $failed = true;
}

$trans_id = $_POST['trans_id']; 
$id_get = $_POST['id_get']; 

$ch = curl_init();     
curl_setopt( $ch, CURLOPT_URL, $url );     
curl_setopt( $ch, CURLOPT_POSTFIELDS, "api=$api&id_get=$id_get&trans_id=$trans_id" );
curl_setopt( $ch, CURLOPT_SSL_VERIFYPEER, FALSE );
curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
$res = curl_exec( $ch );
curl_close( $ch ); 

switch( $res ) 
{
    case '-1' :   
        $plmessage = 'کد api ارسالی با کد api ثبت شده در بیت پی سازگار نیست.';
        $failed = true;
        break;
    case '-2' :  
        $plmessage = 'شماره تراکنش ارسالی نامعتبر است.';
        $failed = true;
        break;   
    case '-3' : 
        $plmessage = 'id_get ارسالی نامعتبر می باشد.';
        $failed = true;
        break;    
    case '-4' :
        $plmessage = 'چنین تراکنشی وجود ندارد و یا قبلا با موفقیت به اتمام رسیده است. همچنین امکان دارد عملیات پرداخت توسط کاربر لغو شده باشد.';
        $failed = true;
        break;  
    case '1' :
        $plmessage = "پرداخت شما با موفقیت دریافت شد. شناسه تراکنش شما: {$trans_id}";
        $failed = false;
        break;
    default:
        $plmessage = "نتیجه تراکنش نامعتبر است.";
        $failed = false;
        break;
}

list($user_id, $sesid) = explode("_", $data['custom']);

$cartrow = $content->getCartContent($sesid);
$totalrow = $content->getCartTotal($sesid);
$gross = $totalrow->total - $totalrow->coupon;

//$mb_currency = $_POST['mb_currency'];
$mb_gross = $data['amount'];
$txn_id = $trans_id;

//$mb_email = getValue("extra", "gateways", "name = 'bitpay'");
$getxn_id = $core->verifyTxnId($txn_id);
if ( ! $failed ) { 
    if ( $mb_gross == $gross && $getxn_id == true) {
        if($cartrow) {
            foreach ($cartrow as $crow) {
                $data = array(
                        'txn_id' => sanitize($txn_id),
                        'pid' => $crow->pid,
                        'uid' => intval($user_id),
                        'downloads' => 0,
                        'file_date' => time(),
                        'ip' => sanitize($_SERVER['REMOTE_ADDR']),
                        'created' => "NOW()",
                        'payer_email' => sanitize($payer_email),
                        'payer_status' => 'verified',
                        'item_qty' => $crow->total,
                        'price' => $crow->total * $crow->price,
                        'currency' => 'IRR',
                        'pp' => "bitpay",
                        'status' => 1,
                        'active' => 1
                );
                $db->insert("transactions", $data);
            }
            
            unset($crow);
        }
        /* == Notify Administrator == */
        require_once ("../../lib/class_mailer.php");
        $row2 = Core::getRowById(Content::eTable, 5);
        $usr = Core::getRowById(Users::uTable, $user->uid);

        $body = str_replace(array(
            '[USERNAME]',
            '[STATUS]',
            '[TOTAL]',
            '[PP]',
            '[IP]'), array(
            $usr->username,
            "Completed",
            $core->formatMoney($gross),
            "PayPal",
            $_SERVER['REMOTE_ADDR']), $row2->body);

        $newbody = cleanOut($body);

        $mailer = Mailer::sendMail();	
        $message = Swift_Message::newInstance()
                  ->setSubject($row2->subject)
                  ->setTo(array($core->site_email => $core->site_name))
                  ->setFrom(array($core->site_email => $core->site_name))
                  ->setBody($newbody, 'text/html');

        $mailer->send($message);

        /* == Notify User == */
        $row3 = Core::getRowById(Content::eTable, 8);
        $val = '
		  <table border="0" cellpadding="4" cellspacing="2">';
        $val .= '
			<thead>
			  <tr>
				<td width="20"><strong>#</strong></td>
				<td class="header">' . Lang::$word->PRD_NAME . '</td>
				<td class="header">' . Lang::$word->PRD_PRICE . '</td>
				<td class="header">' . Lang::$word->TXN_QTY . '</td>
				<td class="header">' . Lang::$word->CKO_TPRICE . '</td>
			  </tr>
			</thead>
			<tbody>';
        $i = 0;
        foreach ($cartrow as $ccrow) {
            $i++;
            $val .= '
				<tr>
				  <td style="border-bottom-width:1px; border-bottom-color:#bbb; border-bottom-style:dashed">' . $i . '.</td>
				  <td style="border-bottom-width:1px; border-bottom-color:#bbb; border-bottom-style:dashed">' . sanitize($ccrow->title,30,false) . '</td>
				  <td style="border-bottom-width:1px; border-bottom-color:#bbb; border-bottom-style:dashed">' . $core->formatMoney($ccrow->price) . '</td>
				  <td align="center" style="border-bottom-width:1px; border-bottom-color:#bbb; border-bottom-style:dashed">' . $ccrow->total . '</td>
				  <td align="right" style="border-bottom-width:1px; border-bottom-color:#bbb; border-bottom-style:dashed">' . $core->formatMoney($ccrow->total * $ccrow->price) . '</td>
				</tr>';
        }
        unset($ccrow);
        $val .= '
			<tr>
			  <td colspan="4" align="right" valign="top" style="border-bottom-width:1px; border-bottom-color:#bbb; border-bottom-style:dashed"><strong>';
        if ($totalrow->coupon != 0) {
            $val .= 'Discount:<br />';
        }
        $val .= 'Sub Total:<br />
				</strong></td>
			  <td align="right" valign="top" style="border-bottom-width:1px; border-bottom-color:#bbb; border-bottom-style:dashed"><strong>';
        if ($totalrow->coupon != 0) {
            $val .= '- ' . $core->formatMoney($totalrow->coupon) . '<br />';
        }
        $val .= $core->formatMoney($gross) . '<br />
				</strong>';
        $val .= ' </td>
			</tr>
			<tr>
			  <td colspan="4" align="right" valign="top"><strong style="color:#F00">Grand Total:</strong></td>
			  <td align="right" valign="top"><strong style="color:#F00">' . $core->formatMoney($gross) . '</strong></td>
			</tr>
			  </tbody>
		  </table>';
        
        $body3 = str_replace(array('[USERNAME]', '[ITEMS]', '[SITENAME]', '[URL]'), 
        array($usr->username, $val, $core->site_url, $core->site_name), $row3->body);
        
        $newbody2 = cleanOut($body3);
        
        $mailer2 = Mailer::sendMail();
        $message2 = Swift_Message::newInstance()
                ->setSubject($row3->subject)
                ->setTo(array($usr->email => $usr->username))
                ->setFrom(array($core->site_email => $core->site_name))
                ->setBody($newbody2, 'text/html');
        
        $mailer2->send($message2);
        
        $db->delete("cart", "user_id='" . $sesid . "'");
        $db->delete("extras", "user_id='" . $sesid . "'");
        $db->delete("recent", "user_id='" . $sesid . "'");

    }
    header("Location: " . SITEURL . "/account.php" );
} else {
    /* == Failed Transaction= = */
    require_once("../../lib/class_mailer.php");
    $row = $core->getRowById("email_templates", 6);
    $usr = $core->getRowById("users", $user_id);


    $body = str_replace(array('[USERNAME]', '[STATUS]', '[TOTAL]', '[PP]', '[IP]'), 
    array($usr->username, "Failed", $core->formatMoney($gross), "bitpay", $_SERVER['REMOTE_ADDR']), $row->body);
    
    $newbody = cleanOut($body);
    
    $mailer = Mailer::sendMail();
    $message = Swift_Message::newInstance()
            ->setSubject($row->subject)
            ->setTo(array($core->site_email => $core->site_name))
            ->setFrom(array($core->site_email => $core->site_name))
            ->setBody($newbody, 'text/html');
    
    $mailer->send($message);
	
	?>
	<!DOCTYPE html>
<html>
    <head>
        <meta charset="utf8" />
        <title>خطا در درگاه بیت پی</title>
    </head>
    <body>
        <?php echo $plmessage; ?>
    </body>
</html>
	<?php
}